#include <stdio.h>
#include <string.h>
#include <alloc.h>
#include <math.h>
#include <ctype.h>
#include <process.h>
#include <stdlib.h>

FILE *infile,*outfile;
char buff[2000];
int linenum;
int multi;

/* Read on a line from input, get rid off strange char, and all space
padding.  Also get rid of any normal or texture normal info as we
don't use them in the 3DS Ascii files anyway.

I can't believe some of the crap I saw in some OBJ files, like nulls
instead of spaces, leading tabs, leading spaces, white space between
numbers.  Like is this ASCII and OBJ a standard or what?

Or how about a polygon with 70 points?  Geesh
*/
void getin(void)
	{
	int off;
	int posi;

//  next two lines for debugging
//	if (linenum==570)
//		printf("Break point set");
	fgets(buff,1999,infile);
	linenum++;
	printf("Line %d\r",linenum);
	// Kill nulls, tabs anything strange
	posi=0;
	while ((buff[posi] != 0x0d) && (buff[posi] != 0x0a))
		{
		// strange
		if (buff[posi] < ' ')
			buff[posi]=' ';
		posi++;
		}
	posi=0;
	//Kill all leading white space
	while ((buff[0] == ' ') && (buff[0] != 0x0d) && (buff[0] != 0x0a))
		memmove(&buff[0],&buff[1],199);
	// Kill any space padding
	while ((buff[posi] != 0x0d) && (buff[posi] != 0x0a))
		{
		// space padding
		if ((buff[posi]==' ') && (buff[posi+1]==' '))
			memmove(&buff[posi],&buff[posi+1],1998-posi);
		else
			posi++;
		}
	if ((toupper(buff[0])=='F') && (strchr(buff,'/') != 0))
		{
		// get rid of the normal and texture normal crap, %$#&, who made
		// made this spec anyway?
		multi=1;
		do
			{
			off=(int)(strchr(buff,'/')-buff);
			do
				memmove(&buff[off],&buff[off+1],1998-off); //yeah yeah, big deal
			while ((buff[off]!=' ') && (buff[off] != 0x0d) && (buff[off] != 0x0a));
			}
		while (strchr(buff,'/') != 0);
		}
	}


/* One nice BIG main procedure, that's the way to do it! */
void main(int argc, char *argv[])
	{
	int nv, np, numnums;
	int t;
	char type[199];
	float n[7];
	long fn[500];
	char tmpbuf[120];
	char *tmpptr;
	char *buffptr;
	int arrcount;

	if (argc<2)
		{
		puts("OBJ2ASC --  Shawn Knight -- June 27, 1993 - Version 0.0");
		puts("");
		puts("Converts OBJ files to 3D-Studio ASCII files");
		puts("Run as:");
		puts("   OBJ2ASC <objfilename> <asciifilename>");
		puts("");
		puts("Better turn 2 sided rendering on, this program may flip normals!");
		puts("");
		puts("Call the Toronto Virtual Reality SIG BBS at (416) 631-6625!");
		puts("");
		puts("Internet:  knights@gov.on.ca");
		exit(1);
		}

	nv=np=linenum=0;
	if ((infile=fopen(argv[1],"rb")) == NULL)
		{
		printf("Can't open %s for input", argv[1]);
		exit(1);
		}
	if ((outfile=fopen("obj2asc.tmp","wb")) == NULL)
		{
		printf("Can't open OBJ2ASC.TMP for output");
		exit(1);
		}

	while (!feof(infile))
		{
		getin();  /* read control line */
		type[0]=0;
		// is this a vertix?
		sscanf(buff, "%s %f %f %f", &type, &n[0], &n[1], &n[2]);
		if ((toupper(type[0])=='V') && (toupper(type[1])!='N'))
				   /* we have a vertex, and not a vertex normal */
			{
			if (nv==0)
				fprintf(outfile,"Vertex list:\nVertex 0: X:0 Y:0 Z:0\n");
			nv++;
			fprintf(outfile,"Vertex %d: X:%f Y:%f Z:%f\n", nv, n[0], n[1],n[2]);
			}
		else if (toupper(type[0])=='F')   /* we have a face */
			{
			// stupid 3dstudio and it's triangles, if we have more than 3
			// vertexs on this face then we gotta break it up, sigh

			buffptr=strchr(buff,' ');  // skip over the "f " or "fo "
			arrcount=0;
			tmpptr=tmpbuf;
			while ((*buffptr !=  0x0d) && (*buffptr != 0x0a))
				{
				buffptr++;
				if ((*buffptr != ' ') && (*buffptr != 0) && (*buffptr !=0x0d)
					&& (*buffptr != 0x0a))
					{
					*tmpptr=*buffptr;
					tmpptr++;
					}
				else
					{
					*tmpptr=0;
					fn[arrcount++]=atol(tmpbuf);
					if (arrcount>498)
						printf("OH OH!");
					tmpptr=tmpbuf;
					}
				}
			arrcount--;
			// now we should have an array of face #'s and arrcount is
			// the # of them
			if (arrcount<2)
				{
				printf("Line #%d -> HEY!  This face has only %d points!",
					linenum,arrcount+1);
				exit(1);
				}
			if (np==0)
				//output a fake face for point 0, since OBJ's start at one
				//and ASC's start at 0... yeah yeah, I should have subtracted
				// 1 from everything, but HEY, you get what you pay for!
				fprintf(outfile,"Face list:\nFace 0: A:0 B:0 C:0\n");
			for (t=1; t<arrcount; t++)
				{
				np++;
				fprintf(outfile,"Face %d: A:%d B:%d C:%d\n", np, (int)fn[0], (int)fn[t], (int)fn[t+1]);
				}
			}
		}
	fclose(infile);
	fclose(outfile);
	// Okay, we have this massive ASC file now, but the start of it
	// states the # of vertices and faces ... so ... lets put it in...
	puts("");
	puts("Writing output file");
	if ((infile=fopen("obj2asc.tmp","rt")) == NULL)
		{
		printf("Can't open OBJ2ASC.TMP for input");
		exit(1);
		}
	if ((outfile=fopen(argv[2],"wt"))== NULL)
		{
		printf("Can't open %s for output", argv[2]);
		exit(1);
		}
	fprintf(outfile,"Named Object: \"TOR-VR-SIG-BBS (416)-631-6625\"\n");
	fprintf(outfile,"Tri-mesh, Vertices: %d Faces: %d\n", nv+1, np+1);
	while (!feof(infile))
		{
		fgets(buff,199,infile);
		fputs(buff,outfile);
		}
	fclose(infile);
	fclose(outfile);
	}

