

/* tddd2dxf.c - convert TDDD (or TTDDD) file to ASC file
 *            - written by Shawn Knight   - 11/30/93
 *            - based on code written by Glenn M. Lewis - 10/29/91
 */

static char rcs_id[] = "$Id: tddd2dxf.c,v 1.1 1992/07/29 20:46:07 glewis Exp $";
unsigned char defclst[3], defrlst[3], deftlst[3], defspc1[3];

#include <stdio.h>
#include "ttdddlib.h"

main(argc, argv)
int argc;
char *argv[];
{
	char filename[256], rootname[256], *c1, *c2;
	int i;
	WORLD *world;
	FILE *inp, *out;

    fprintf(stderr, "Shawn Knight -- Toronto Virtual Reality SIG -- 416-631-6625 -- 24 Hours\n");
    fprintf(stderr, "On the net:  knights@gov.on.ca\n");
    fprintf(stderr, "\n");
    fprintf(stderr, "TDD2ASC <infile> <outfile>\n");
    fprintf(stderr, "         (TDDD)   (ASC)\n");
    fprintf(stderr, "\n");
    fprintf(stderr, "Turn on Force 2-sided rendering in 3DStudio since this program doesn't\n");
    fprintf(stderr, "care anything about normals!\n");
    fprintf(stderr, "\n");

	filename[0] = '\0';
	rootname[0] = '\0';
	for (i=1; i<argc; i++) {
		if (argv[i][0] == '-') {
            fprintf(stderr, "Unknown option '%s' ignored.\n", argv[i]);
		} else if (filename[0]) {
			strcpy(rootname, argv[i]);
		} else {
			strcpy(filename, argv[i]);	/* Make root of filename the default */
			for (c1=rootname,c2=argv[i]; (*c1 = *c2++) && *c1!='.'; c1++) ;
			*c1 = '\0';
			strcat(rootname, ".asc");
		}
	}

	if (!filename[0]) inp = stdin;
	else if (!(inp = fopen(filename, "rb"))) {
		fprintf(stderr, "Can't open '%s' for input.\n", filename);
		exit(-1);
	}
	if (!rootname[0]) out = stdout;
	else if (!(out = fopen(rootname, "wb"))) {
		fprintf(stderr, "Can't open '%s' for output.\n", rootname);
		exit(-1);
	}

	world = read_World(inp);
	write_ASC(world, out);
	free_World(world);
	exit(0);
}

